uses Graph, Crt, Stack, Ramka, Menus;

type
  TPtr = ^TElem;
  TElem = record
    inf: Integer;
    Link: TPtr;
  end;

var
  BegQ, EndQ: TPtr;
  Gd, Gm, i, Value: Integer;
  Res: Byte;
  ValStr: String;

procedure DrawTree;
  var i: Integer;
      P: TPtr;
begin
  TextBackGround(0);
  ClrScr;
  ProcRamka(1, 1, 80, 10, 15, 1, 1, 2, ' ');
  TextColor(14);
  TextBackGround(1);
  P:=BegQ;
  i:=1;
  DrawNextEl(15, P^.Inf, 9*(i-1)+2, 2);
  i:=2;
  repeat
    if P^.Link<>nil then begin
      P := P^.Link;
      DrawNextEl(15, P^.Inf, 9*(i-1)+2, 2);
    end;
    Inc(i);
  until P^.Link=nil;
  ReadKey;
end;

procedure Message(S: String);
begin
  GotoXY(1, 25);
  TextColor(0);
  TextBackGround(7);
  DelLine;
  Write(S);
end;

procedure AddEl(Val: Integer);
  var P: TPtr;
begin
  New(P);
  P^.inf := Val;
  P^.Link := nil;
  if BegQ = nil then BegQ := P
    else EndQ^.Link := P;
  EndQ := P;
end;

procedure GetEl(var Val, Num: Integer);
  var P: TPtr;
      i: Integer;
begin
  P:=BegQ;
  i:=1;
  if i=Num then Val := P^.Inf;
  i:=2;
  repeat
    if P^.Link<>nil then begin
    P := P^.Link;
    if i=Num then Val := P^.Inf;
    end;
    Inc(i);
  until P^.Link=nil;
end;

procedure DelEl;
  var P: TPtr;
begin
  P := BegQ;
  BegQ := P^.Link;
  if BegQ = nil then EndQ := nil;
  Dispose(P);
end;

begin
  BegQ:=nil;
  EndQ:=nil;
  repeat
    menu('menu.txt', 15, 1, 15, 7, 0, Res);
    case Res of
      1: begin
           Message(' ᫮: ');
           Read(Value);
           AddEl(Value);
         end;
      2: begin
           if BegQ<>nil then begin
             Message('  : ');
             Read(Value);
             i:=Value;
             GetEl(Value, i);
             Str(Value, ValStr);
             Message(': '+ValStr);
             ReadKey;
           end
             else begin
                 Message('। ');
                 ReadKey;
             end;
         end;
      3: begin
           if BegQ<>nil then begin
             Message('  ');
             ReadKey;
             DelEl;
           end
             else begin
                 Message('। ');
                 ReadKey;
             end;
         end;
      4: begin
           if BegQ<>nil then
             DrawTree
               else begin
                 Message('। ');
                 ReadKey;
               end;
         end;
    end;
  until Res=5;
end.